<!-- Loading component -->
<template>
  <b-overlay
    :show="busy"
    no-wrap
  >
    <template #overlay>
      <div
        v-if="processing"
        class="text-center p-4 bg-primary text-light rounded"
      >
        <b-icon
          icon="disc"
          animation="spin-pulse"
          font-scale="4"
        />
        <div class="mb-3">
          Chargement...
        </div>
        <b-progress
          min="1"
          max="20"
          :value="counter"
          variant="success"
          height="3px"
          class="mx-n4 rounded-0"
        />
      </div>
    </template>
  </b-overlay>
</template>

<script>
export default {
  name: 'Overlay',
  props: {
    loading: Boolean
  },
  data () {
    return {
      // Allows the component to be displayed
      busy: false,
      // Allows you to display the custom design of the loader
      processing: false,
      counter: 7
    }
  },
  watch: {
    /**
     * Listen to the props loading, if true we display the loading otherwise we close it
     * @param val {Boolean}
     */
    loading (val) {
      if (val) {
        this.processing = true
        this.busy = true
      } else {
        this.processing = false
        this.busy = false
      }
    }
  }
}
</script>

<style scoped>

</style>
